'(c) 2016 Ramesh Srinivasan.
'This script clears the folder view settings to defaults in Explorer.
'Script written on Feb 03, 2016
'Last modified on May 05, 2016
'http://www.winhelponline.com/blog

Option Explicit
Dim WshShell, strBagsKeyPath, Rtn, strBagMRUKeyPath, strDelCmd, Process, strMsg
Dim strBackCmd, strExportFile, strTimeStamp
Set WshShell = WScript.CreateObject("WScript.Shell")
strBagsKeyPath = "HKCU\SOFTWARE\Classes\Local Settings\Software\Microsoft\Windows\Shell\Bags\"
strBagMRUKeyPath = "HKCU\SOFTWARE\Classes\Local Settings\Software\Microsoft\Windows\Shell\BagMRU\"

strMsg = "This script will reset folder view settings and restart the Explorer Shell. "
strMsg = strMsg & "The Bags and BagMRU keys will be backed up to your desktop before being erased. "
strMsg = strMsg & "Click Yes to continue."
If MsgBox (strMsg, vbYesNo, "Reset Folder Views") = vbNo Then
	WScript.Quit
End If

BackupSavedViews
WScript.Sleep(1000)
ClearSavedViews
ClearNavSettings
RestartShell
WScript.Sleep(2000)

MsgBox "Folder view settings are reset", vbOKOnly, "Reset Folder Views"

Sub BackupSavedViews()
	strTimeStamp = DatePart("yyyy",Date) & Right("0" & DatePart("m",Date), 2) & Right("0" & DatePart("d",Date), 2)
	strTimeStamp = strTimeStamp & "-" &  Right("0" & Hour(Now), 2) & Right("0" & Minute(Now), 2) & Right("0" & Second(Now), 2)
	strExportFile = WshShell.SpecialFolders("Desktop") & "\backup-bags-" & strTimeStamp & ".txt"
	strBackCmd = "%comspec% /k reg.exe EXPORT " & Chr(34) & Left(strBagsKeyPath, Len(strBagsKeyPath) -1) & Chr(34) & _
	" " & Chr(34) & strExportFile & Chr(34)
	WshShell.Exec strBackCmd
	strExportFile = WshShell.SpecialFolders("Desktop") & "\backup-bagmru-" & strTimeStamp & ".txt"
	strBackCmd = "%comspec% /k reg.exe EXPORT " & Chr(34) & Left(strBagMRUKeyPath, Len(strBagMRUKeyPath) -1) & Chr(34) & _
	" " & Chr(34) & strExportFile & Chr(34)
	WshShell.Exec strBackCmd
End Sub

Sub ClearSavedViews()
	strDelCmd = "%comspec% /k reg.exe DELETE " & Chr(34) & Left(strBagsKeyPath, Len(strBagsKeyPath) -1) & Chr(34) & " /F"
	WshShell.Exec strDelCmd
	WScript.Sleep(1000)
	strDelCmd = "%comspec% /k reg.exe DELETE " & Chr(34) & Left(strBagMRUKeyPath, Len(strBagMRUKeyPath) -1) & Chr(34) & " /F"
	WshShell.Exec strDelCmd
End Sub

Sub ClearNavSettings()
	strDelCmd = "%comspec% /k reg.exe DELETE " & Chr(34) & "HKCU\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Modules" & Chr(34) & " /F"
	WshShell.Exec strDelCmd
	WScript.Sleep(1000)
End Sub

Sub RestartShell()
	For Each Process In GetObject("winmgmts:"). _
		ExecQuery ("select * from Win32_Process where name='explorer.exe'")
		Process.terminate(0)
	Next
End Sub

Set WshShell = Nothing